﻿' <summary>
' SmartI/O ADC 1~4 테스트
' SmartX : SmartADC
' 기능 : 거리,압력,조도,온도,자이로,가속도센서등.. Analog센서값 처리
' 응용분야 : 센서사용 측정분야
' 항목 : 거리센서 - SHARP(GP2Y0A41SK0F)
'        압력센서 - Smate(33A-030G-2210)
' 주의사항 : 
' </summary>

Public Class Form1

    ' ReadDetailFitering의 인자값
    Private m_iRawData As Integer
    Private m_iAvailable As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' SmartDraw BackGround 설정
        smartDraw1.BackLayer.SetPenStyle(Color.Blue, 3)
        smartDraw1.BackLayer.Line(50, 10, 50, 317)
        smartDraw1.BackLayer.Line(10, 297, 500, 297)
        smartDraw1.BackLayer.SetPenStyle(Color.Gray, 1)
        smartDraw1.BackLayer.SetFont(16, Color.White)

        ' Chart의 가로 그리드 그리기
        Dim j As Integer = 10
        For i As Integer = 0 To 6
            smartDraw1.BackLayer.Line((70 * i) + 50, 17, (70 * i) + 50, 297)
            smartDraw1.BackLayer.TextOut((70 * i) + 42, 307, j.ToString())
            j += 10
        Next

        ' Chart의 세로 그리드 그리기
        j = 455
        For i As Integer = 1 To 9
            smartDraw1.BackLayer.Line(50, 320 - (i * 30) - 23, 480, 320 - (i * 30) - 23)
            smartDraw1.BackLayer.TextOut(10, 315 - (i * 30) - 26, j.ToString())
            j += 455

            If i = 8 Then
                j = 4095
            End If
        Next

        ' 그래프를 그리기 위한 Chart를 설정
        ' (인자를 생략하여 폼디자이너의 속성창에서 설정한 값으로 설정)
        smartDraw1.Chart.SetChartConfig()

        ' SmartTimer Interval 설정
        SmartTimer1.Interval = 10
        ' PutData() 메서드가 4번 호출되었을 때 Chart화면 갱신
        smartDraw1.Chart.ChartDrawStep = 4

        ' Filtering 설정 영역을 숨김
        smartGroupBox1.Visible = False
    End Sub

    ' Adc 값 읽어서 표시하는 Timer
    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        Dim iVal As Integer = 0, iVal1 As Integer = 0, iVal2 As Integer = 0, iVal3 As Integer = 0
        Dim iADCVal As Double = 0, iADCVal1 As Double = 0, iADCVal2 As Double = 0, iADCVal3 As Double = 0

        If btnADC0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            If chkFiltering.Checked = True Then
                ' ADC0 데이터를 얻어온다.
                iVal = SmartADC1.ReadDataDetailFiltering(0, m_iRawData, m_iAvailable)
            Else
                ' ADC0 데이터를 얻어온다.
                iVal = SmartADC1.ReadData(0)
            End If

            ' 거리측정계산 함수
            ADC0_DataParsing(iVal)
        Else
            labADCValue0.Text = ""
            labADCDistance0.Text = ""
        End If

        If btnADC1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            If chkFiltering.Checked = True Then
                ' ADC1 데이터를 얻어온다.
                iVal1 = SmartADC1.ReadDataDetailFiltering(1, m_iRawData, m_iAvailable)
            Else
                ' ADC1 데이터를 얻어온다.
                iVal1 = SmartADC1.ReadData(1)
            End If

            ' 압력측정계산 함수
            ADC1_DataParsing(iVal1)
        Else
            labADCValue1.Text = ""
            labADCPressure1.Text = ""
        End If

        If btnADC2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            If chkFiltering.Checked = True Then
                ' ADC2 데이터를 얻어온다.
                iVal2 = SmartADC1.ReadDataDetailFiltering(2, m_iRawData, m_iAvailable)
            Else
                ' ADC2 데이터를 얻어온다.
                iVal2 = SmartADC1.ReadData(2)
            End If
        Else
            labADCValue2.Text = ""
        End If

        If btnADC3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then

            If chkFiltering.Checked = True Then
                ' ADC3 데이터를 얻어온다.
                iVal3 = SmartADC1.ReadDataDetailFiltering(3, m_iRawData, m_iAvailable)
            Else
                ' ADC3 데이터를 얻어온다.
                iVal3 = SmartADC1.ReadData(3)
            End If
        Else
            labADCValue3.Text = ""
        End If

        ' ADC 값 표시
        labADCValue0.Text = iVal.ToString()
        labADCValue1.Text = iVal1.ToString()
        labADCValue2.Text = iVal2.ToString()
        labADCValue3.Text = iVal3.ToString()

        ' 그래프에 4채널의 데이터를 표시 하기위한 계산
        iADCVal = (CDbl(iVal) / 4096)
        iADCVal1 = (CDbl(iVal1) / 4096)
        iADCVal2 = (CDbl(iVal2) / 4096)
        iADCVal3 = (CDbl(iVal3) / 4096)

        iVal = CInt((CDbl(270.0) * iADCVal))
        iVal1 = CInt((CDbl(270.0) * iADCVal1))
        iVal2 = CInt((CDbl(270.0) * iADCVal2))
        iVal3 = CInt((CDbl(270.0) * iADCVal3))

        ' 그래프의 데이터를 입력 합니다. (인자의 수에 맞추어 그래프의 각각의 계열에 적용됨)     
        smartDraw1.Chart.PutData(iVal, iVal1, iVal2, iVal3)
    End Sub

    Private Sub chkFiltering_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chkFiltering.Click
        If chkFiltering.Checked = True Then
            smartGroupBox1.Visible = True
        Else
            smartGroupBox1.Visible = False
        End If
    End Sub

    Private Sub btnADCStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnADCStart.Click
        ' DetailFiltering 선택 시
        If chkFiltering.Checked = True Then
            ' RawDataCnt값이나 AvailabelCnt 값이 라벨에 입력되어 있지 않다면 실행 취소
            If (labRawCnt.Text = "") OrElse (labAvailableCnt.Text = "") Then
                SmartX.SmartMessageBox.Show("RawData값과 Available 값을 설정하세요")
                Return
            Else
                ' RawDataCnt 값을 라벨에 입력된 값으로 설정
                m_iRawData = Convert.ToInt32(labRawCnt.Text)

                ' AvailableCnt값을 라벨에 입력된 값으로 설정
                m_iAvailable = Convert.ToInt32(labAvailableCnt.Text)

                ' 입력된 AvailableCnt값이 1 ~ RawDataCnt - 2 사이의 값이 아닌 경우 실행 취소
                If (m_iAvailable < 1) OrElse (m_iAvailable > (m_iRawData - 2)) Then
                    SmartX.SmartMessageBox.Show("Available값 범위는 1 ~ " & (m_iRawData - 2).ToString() & "입니다.")
                    ' 값을 초기화
                    labAvailableCnt.Text = "1"
                    Return
                End If
            End If
        End If

        If btnADCStart.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
            ' ADC Start
            SmartTimer1.Start()
            chkFiltering.Enabled = False
        ElseIf btnADCStart.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            ' ADC Stop
            SmartTimer1.Stop()
            chkFiltering.Enabled = True
        End If
    End Sub

    Private Sub SmartLabel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labRawCnt.Click, labAvailableCnt.Click
        If sender Is labRawCnt Then
            smartKeyboard1.Show(154, 236, labRawCnt)
        Else
            smartKeyboard1.Show(336, 236, labAvailableCnt)
        End If
    End Sub

    ' 센서 특성상 선형적이지 않을경우 구간별로 측정해야 합니다. 
    ' ADC0 센서값을 거리로 계산해주는 공식. 20cm ~ 50cm 구간 사이 변환 공식
    ' 본 코드는 AD값으로 거리를 계산하는 공식이며 AD값에 따라 거리값의 증/감이 비교적 비례하는 구간을 계산한 공식입니다. 
    ' AD값의 구간별로 정확하게 거리를 계산하기위해서는 AD구간별로 계산공식이 필요합니다.
    Private Sub ADC0_DataParsing(ByVal val As Double)
        ' 거리센서의 ADC값 = 1064는 거리20cm, ADC값 = 491은 거리50cm 입니다.
        ' ADC값 1064 - 491 = 573(ADC구간) 이고 20cm ~ 50cm(ADC의 거리구간)
        ' 계산공식은 573 : 30 = (1064 - val) : x 의 결과값에 20(출발점)을 더합니다.

        ' ADC값
        labADCValue0.Text = val.ToString()
        ' 거리값
        labADCDistance0.Text = Math.Round(((((1064 - val) * 30) / 573) + 20), 0).ToString() & "cm"
    End Sub

    Private Sub ADC1_DataParsing(ByVal val As Double)
        ' Input Valtage
        Dim dInputValt As Double = (4.5 / 4096.0) * val

        labADCValue1.Text = val.ToString()

        labADCPressure1.Text = Math.Round(((((dInputValt - 0.5) * 30) / (5 * 0.8))), 0).ToString() & "PSI"
    End Sub
End Class
